#ifndef _LOCK_H_
#define _LOCK_H_

typedef volatile int lock_t;

#define atomic_swap(val, lock)\
({\
   int ret;\
   __asm__ volatile ("lock; xchgl %%eax,(%%ebx);":"=a"(ret):"a"(val),"b"(&lock));\
   ret;\
})

#define LOCK_INIT(lock) lock = 0

#define LOCK_WAIT(lock)\
   {\
      while(atomic_swap(1,lock));\
   }

#define LOCK_SIGNAL(lock)\
   {\
      atomic_swap(0,lock);\
   }

#endif
