/*

This file is part of aiorOS

aiorOS - 32bit Operating System.
Copyright (C) 2005  Salvatore Iengo <salvatoreiengo@hotmail.com>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef _TIMER_H_
#define _TIMER_H_

#include <io.h>
#include <kernel.h>
#include <vga.h>
#include <irq.h>
#include <task.h>

#define TIMER_HERTZ 100

typedef struct{
   int sec;
   int min;
   int hour;
   int day;
   int month;
   int year;
}datetime_t;

void initTimer(void);

/* RTC functions */
datetime_t getDatetimeNow(void);
char *datetimeToString(datetime_t dt, char *str);
datetime_t stringToDatetime(char *);

#endif
