/*

This file is part of aiorOS

aiorOS - 32bit Operating System.
Copyright (C) 2005  Salvatore Iengo <salvatoreiengo@hotmail.com>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#ifndef _TYPES_H_
#define _TYPES_H_

#include <std/stddef.h>

#define word unsigned short int
#define dword unsigned int
#define qword unsigned long
#define byte unsigned char
#define bool byte
#define true 1
#define false 0

#define CLI() __asm__ volatile("cli")
#define STI() __asm__ volatile("sti")

#define DELAY() {int count; for(count=0;count<0x00FFFFFF;count++);}

#define KERNEL_MODE 0x0
#define USER_MODE 0x3

#define CLEAR_BIT(b,n) (b&= ~(1<<n))
#define SET_BIT(b,n) (b|=(1<<n))
#define IS_SET_BIT(b,n) (b & (1<<n))

#endif
