/*

This file is part of aiorOS

aiorOS - 32bit Operating System.
Copyright (C) 2005  Salvatore Iengo <salvatoreiengo@hotmail.com>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

#include <queue.h>

void initQueue(queue_t *q){
   if(q){
      q->count = 0;
      q->head = q->tail = 0;
   }
}

void enqueue(queue_t *q, char c){
   if(q){
      if(q->count<MAX_QUEUE){
         if(q->count==0)
            q->head = q->tail = 0;
         else
            q->tail = (q->tail + 1) % MAX_QUEUE;
         q->mem[q->tail] = c;
         q->count++;
      }
   }
}

char dequeue(queue_t *q){
   if(q){
      if(q->count>0){
         char tmp;
         tmp = q->mem[q->head];
         q->head = (q->head + 1) % MAX_QUEUE;
         q->count--;
         return tmp;
      }
   }
   return -1;
}

char enqueueUndo(queue_t *q){
   if(q){
      if(q->count>0){
         char tmp;
         tmp = q->mem[q->tail];
         q->count--;
         if(q->tail==0)
            q->tail = MAX_QUEUE-1;
         else
            q->tail--;
         return tmp;
      }
   }
   return -1;
}
